#open "logo_base";;


(* TYPES DE DONNEES							*)

(* type des instructions : A DEFINIR					*)
type instruction;;

(* type des dfinitions de procedure : A DEFINIR			*)
type definition;;

(* type des programmes : A DEFINIR					*)
type programme;;

(* type des environnements contenant des dfinitions de procdures	*)
(* et de variables : A DEFINIR						*)
type environnement;;

(* type des tats du systme                                            *)
type etat;;

(* ANALYSE SYNTAXIQUE							*)

(* lecture d'un bloc d'instructions 'BEGIN ... END' : A DEFINIR		*)
(* le mot-cl BEGIN est suppos DEJA LU	(on commence  lire la premire	*)
(* instruction), le mot-cl END est A LIRE obligatoirement en dernier	*)
value lit_bloc : flux_lecture -> instruction list;;

(* lecture d'une dfinition de procdure : A DEFINIR			*)
(* une dfinition comprend le nom, les paramtres et le bloc associ	*)
(* le mot-cl DEF est suppos DEJA LU (on commence  lire le nom)	*)
value lit_definition : flux_lecture -> definition;;

(* lecture d'un programme : A DEFINIR					*)
(* un programme comprend les dfinitions et le bloc principal		*)
value lit_programme : flux_lecture -> programme;;


(* EVALUATION								*)

(* valuation d'une expression 'expr' dans 'environnement' : A DEFINIR	*)
value evalue_expression : environnement -> expr -> float;;

(* valuation d'une condition 'test' dans 'environnement' : A DEFINIR	*)
value evalue_condition : environnement -> test -> bool;;

(* excution de 'instruction' dans 'environnement' depuis la position	*)
(* 'etat'. Renvoie le nouvel tat atteint : A DEFINIR			*)
value execute_instruction : environnement -> instruction -> etat -> etat;;

(* excution de 'programme'  partir de la position initiale            *)
(* (0.0, 0.0, 0.0), avec couleur noire et mode sans remplissage         *)
(* A DEFINIR								*)
value execute_programme : programme -> unit;;
